package flags

type Set []Flag

func NewSet() Set {
	return Set{}
}

func (s Set) Add(f Flag) Set {
	return append(s, f)
}

func (s Set) Get(name string) (Flag, bool) {
	for _, f := range s {
		if f.Name() == name {
			return f, true
		}

		if f.ShortName() == name {
			return f, true
		}
	}
	return nil, false
}

func (s Set) MaxWidth() int {
	max := 0
	for _, f := range s {
		if w := len(Names(f)); w > max {
			max = w
		}
	}
	return max
}

// TODO: Implement
func (s Set) Parse(args []string) error {
	return nil
}
